## lensfun 0.3.3

=== CMakeLists.txt ===
# require at least cmake 2.8
CMAKE_MINIMUM_REQUIRED(VERSION 2.8 FATAL_ERROR )

# path for helper modules
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake/modules")
GET_FILENAME_COMPONENT(SOURCE_BASE_DIR ${CMAKE_SOURCE_DIR} PATH CACHE)

#  global setup
project(lensfun C CXX)

# version
SET(VERSION_MAJOR 0)
SET(VERSION_MINOR 3)
SET(VERSION_MICRO 3)
SET(VERSION_BUGFIX 0)
SET(VERSION_API 1)
# This is the version of the *shipped* database, which is not necessarily the
# highest version number supported
SET(LENSFUN_DB_VERSION 1)

# check if some include are available
INCLUDE(CheckIncludeFiles)
CHECK_INCLUDE_FILES(regex.h HAVE_REGEX_H)
CHECK_INCLUDE_FILES(endian.h HAVE_ENDIAN_H)

# set include directories
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include/lensfun)
IF(NOT HAVE_REGEX_H)
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include/regex)
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/libs/regex)
ENDIF()

IF(CMAKE_SYSTEM_PROCESSOR MATCHES "[XxIi][0-9]?86|[Aa][Mm][Dd]64")
  SET(X86_ON ON)
else()
  SET(X86_ON OFF)
ENDIF()

# options controlling the build process
OPTION(BUILD_STATIC "Build static library" OFF)
OPTION(BUILD_TESTS "Build test suite" OFF)
OPTION(BUILD_LENSTOOL "Build the lenstool (requires libpng)" OFF)
OPTION(BUILD_FOR_SSE "Build with support for SSE" ${X86_ON})
OPTION(BUILD_FOR_SSE2 "Build with support for SSE2" ${X86_ON})
OPTION(BUILD_DOC "Build documentation with doxygen" OFF)
OPTION(INSTALL_HELPER_SCRIPTS "Install various helper scripts" ON)

IF(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug CACHE STRING
       "Choose the type of build, options are: Debug, Release"
       FORCE
  )
ENDIF()

# set local install prefix on windows
IF(WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)  
  SET(CMAKE_INSTALL_PREFIX "${CMAKE_SOURCE_DIR}/install" CACHE PATH "Install prefix for Lensfun" FORCE)    
ENDIF()
# get standard GNU install directories for the current platform
INCLUDE(GNUInstallDirs)
IF(NOT DEFINED CMAKE_INSTALL_DATAROOTDIR)
  SET(CMAKE_INSTALL_DATAROOTDIR "share" CACHE PATH "read-only architecture-independent data root (share)")
ENDIF()
IF (WIN32)
    SET(LENSFUN_WINDOWS_DATADIR ${CMAKE_INSTALL_DATAROOTDIR}/lensfun CACHE PATH "Directory for library data files. This should be relative to the location where the lensfun.dll will be installed.")
ENDIF()

IF(BUILD_FOR_SSE)
  SET(VECTORIZATION_SSE 1)
  IF(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    SET(VECTORIZATION_SSE_FLAGS "-msse")
  ENDIF()
ENDIF()
IF(BUILD_FOR_SSE2)
  SET(VECTORIZATION_SSE2 1)
  IF(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    SET(VECTORIZATION_SSE2_FLAGS "-msse2")
  ENDIF()
ENDIF()

IF(WIN32)
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/libs/getopt)
  # base path for searching for glib on windows
  IF(NOT GLIB2_BASE_DIR)
    SET(GLIB2_BASE_DIR "${SOURCE_BASE_DIR}/glib-2.28.1" CACHE STRING "Base path of glib2 dir." FORCE)
  ENDIF()
  # install glib dll on windows next to lensfun.dll
  IF (GLIB2_DLL)
    INSTALL(FILES ${GLIB2_DLL} DESTINATION ${CMAKE_INSTALL_BINDIR})
  ENDIF()
ENDIF()


IF (BUILD_TESTS)
  # automatic tests need at least glib version 2.40
  # NOTE: must be one of the macros listed in https://developer.gnome.org/glib/stable/glib-Version-Information.html
  SET(LENSFUN_GLIB_REQUIREMENT_MACRO "GLIB_VERSION_2_40")
  FIND_PACKAGE(GLIB2 REQUIRED)
ELSE()
  SET(LENSFUN_GLIB_REQUIREMENT_MACRO "GLIB_VERSION_2_26")
  FIND_PACKAGE(GLIB2 REQUIRED)
ENDIF()

INCLUDE_DIRECTORIES(SYSTEM ${GLIB2_INCLUDE_DIRS})
LINK_DIRECTORIES(${GLIB2_LIBRARY_DIRS})


IF(BUILD_STATIC)
  ADD_DEFINITIONS(-DCONF_LENSFUN_STATIC)
ENDIF()


# some windows and MSVC specific settings
IF(WIN32)
  SET(PLATFORM_WINDOWS 1)  
  
  IF (MSVC)
    IF(BUILD_STATIC)
      # compile everything for the static C runtime
      FOREACH(TYPE C CXX)
        # makefiles use blank configuration
        FOREACH(CFG "_DEBUG" "_MINSIZEREL" "_RELEASE" "_RELWITHDEBINFO")
          SET(NEW_FLAGS "${CMAKE_${TYPE}_FLAGS${CFG}}")
          # fix up static libc flags
          STRING(REPLACE "/MD" "/MT" NEW_FLAGS "${NEW_FLAGS}")
          # *FORCE* to override whats already placed into the cache
          SET(CMAKE_${TYPE}_FLAGS${CFG} "${NEW_FLAGS}" CACHE STRING
            "CMAKE_${TYPE}_FLAGS${CFG} (overwritten to ensure static build)" FORCE)
        ENDFOREACH(CFG)
      ENDFOREACH(TYPE)
      # link only with the static C runtime !! THIS IS A MUST !!
      SET(NEW_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
      # ensure that the flags are not duplicaated on subsequent runs
      STRING(REPLACE " /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\"" "" NEW_FLAGS "${NEW_FLAGS}")
      # note that flag names (NODEFAULTLIB) etc.) are case sensitive
      SET(CMAKE_EXE_LINKER_FLAGS
          "${NEW_FLAGS} /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\""
          CACHE STRING "for MSVC" FORCE
      )
    ENDIF()
  ENDIF(MSVC)
ENDIF(WIN32)

# create config.h file
CONFIGURE_FILE(include/lensfun/config.h.in.cmake ${CMAKE_BINARY_DIR}/config.h)
# create lensfun.h file
CONFIGURE_FILE(include/lensfun/lensfun.h.in ${CMAKE_BINARY_DIR}/lensfun.h @ONLY)

# include libs
ADD_SUBDIRECTORY(libs)

# build the test suite
IF(BUILD_TESTS)
    enable_testing()
    ADD_SUBDIRECTORY(tests)
ENDIF()

# apps subdir
ADD_SUBDIRECTORY(apps)

# install include files
INSTALL(FILES ${CMAKE_BINARY_DIR}/lensfun.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lensfun)
IF(NOT HAVE_REGEX_H)
  INSTALL(FILES include/regex/regex.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/regex)
ENDIF()

# install db files
FILE(GLOB DATABASE_FILES data/db/*.xml)
INSTALL(FILES ${DATABASE_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/lensfun/version_${LENSFUN_DB_VERSION})
INSTALL(FILES data/db/timestamp.txt DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/lensfun/version_${LENSFUN_DB_VERSION})

# build documentation
IF(BUILD_DOC)
  ADD_SUBDIRECTORY(docs)
ENDIF()

IF(WIN32 AND NOT BUILD_STATIC)
  FIND_FILE(GLIB2_DLL 
            NAMES glib-2.dll glib-2-vs9.dll
            PATHS "${GLIB2_BASE_DIR}/bin"
            NO_SYSTEM_ENVIRONMENT_PATH)
  INSTALL(FILES ${GLIB2_DLL} DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()

# print some information
MESSAGE(STATUS "-------------------------------------------------------------------------------------")
MESSAGE(STATUS "Building Lensfun ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}")
MESSAGE(STATUS "-------------------------------------------------------------------------------------")
IF(BUILD_STATIC)
  MESSAGE(STATUS "Build as static library")
ELSE()
  MESSAGE(STATUS "Build as dynamic/shared library")
ENDIF()
MESSAGE(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
MESSAGE(STATUS "Build doc: ${BUILD_DOC}")
MESSAGE(STATUS "Build test suite: ${BUILD_TESTS}")
MESSAGE(STATUS "Build lenstool: ${BUILD_LENSTOOL}")
MESSAGE(STATUS "Build with support for SSE: ${BUILD_FOR_SSE}")
MESSAGE(STATUS "Build with support for SSE2: ${BUILD_FOR_SSE2}")
MESSAGE(STATUS "Install helper scripts: ${INSTALL_HELPER_SCRIPTS}")
MESSAGE(STATUS "\nInstall prefix: ${CMAKE_INSTALL_PREFIX}")
MESSAGE(STATUS "\nUsing: ")
MESSAGE(STATUS "GLIB2 include dir: ${GLIB2_INCLUDE_DIRS}")
MESSAGE(STATUS "GLIB2 library: ${GLIB2_LIBRARIES}")
IF(GLIB2_DLL)
MESSAGE(STATUS "GLIB2 DLL: ${GLIB2_DLL}")
ENDIF()
IF(BUILD_APPS)
MESSAGE(STATUS "libpng include dir: ${PNG_INCLUDE_DIR}")
MESSAGE(STATUS "libpng lib: ${PNG_LIBRARY}")
MESSAGE(STATUS "zlib include dir: ${ZLIB_INCLUDE_DIR}")
MESSAGE(STATUS "zlib lib: ${ZLIB_LIBRARY}")
ENDIF()

# Package
# This needs some testing, in particular for right package naming for different
# package managers and distributions. Debian works fine.
SET(CPACK_PACKAGE_NAME "lensfun")
SET(CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${VERSION_MICRO}.${VERSION_BUGFIX}")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "CMake ${V_MAJOR}.${V_MINOR}")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}")
SET(CPACK_SOURCE_GENERATOR "TGZ;TBZ2")
SET(CPACK_PACKAGE_CONTACT "zap@homelink.ru")
SET(CPACK_SET_DESTDIR "ON")
IF(BUILD_AUXFUN)
  SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libglib2.0-0 (>=2.0.0), libpng (>=1.0), zlib (>=1.0)")
ELSE()
  SET(CPACK_DEBIAN_PACKAGE_DEPENDS "libglib2.0-0 (>=2.0.0)")
ENDIF()

IF(CPACK_BINARY_DEB)
  # workaround to set correct debian package name
  SET(CPACK_DEBIAN_PACKAGE_NAME "liblensfun${VERSION_API}")
  STRING(TOLOWER "${CPACK_DEBIAN_PACKAGE_NAME}" CPACK_PACKAGE_NAME_LOWERCASE)
  FIND_PROGRAM(DPKG_PROGRAM dpkg DOC "dpkg program of Debian-based systems")
  if(DPKG_PROGRAM)
      EXECUTE_PROCESS(
          COMMAND ${DPKG_PROGRAM} --print-architecture
          OUTPUT_VARIABLE CPACK_DEBIAN_PACKAGE_ARCHITECTURE
          OUTPUT_STRIP_TRAILING_WHITESPACE
      )
      SET(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME_LOWERCASE}_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}_${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")
  else(DPKG_PROGRAM)
      SET(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME_LOWERCASE}_${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_MICRO}.${VERSION_BUGFIX}_${CMAKE_SYSTEM_NAME}")
  endif(DPKG_PROGRAM)
ENDIF(CPACK_BINARY_DEB)

INCLUDE(CPack)

=== debian/changelog ===
lensfun (0.3.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #1007720)
  * Update standards version to 4.6.0, no changes needed.
  * Sort install files.
  * Use execute_before_dh_auto_clean to avoid invoking dh_auto_clean manually.
  * Update the patches:
    - upstream_Use-database-in-source-directory-while-running-tests.patch:
      drop, backported from upstream
    - upstream_Patch-47-respect-DESTDIR-when-installing-python-stuf.patch:
      drop, backported from upstream
  * Change the python3 build dependency to python3:any, as Python is needed
    only as build tool.
  * Drop the "uupdate" step from the watch file.

 -- Pino Toscano <pino@debian.org>  Tue, 15 Mar 2022 22:03:42 +0100

=== debian/control ===
Source: lensfun
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>,
 Pino Toscano <pino@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, pkg-config, python3:any, libglib2.0-dev,
 dh-python,
 doxygen,
 python3-docutils,
Standards-Version: 4.6.0
Section: libs
Rules-Requires-Root: no
Homepage: https://lensfun.github.io/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/lensfun
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/lensfun.git

Package: liblensfun-dev
Section: libdevel
Architecture: any
Depends: liblensfun1 (= ${binary:Version}), ${misc:Depends}
Description: Lens Correction library - Development files
 Lensfun is an opensource database of photographic lenses and their
 characteristics. It contains three kinds of objects:
  * mounts
  * cameras
  * lenses
 .
 It is used in various photo-related software in which it allows the
 correction of various artifacts:
  * distortion
  * transveral (also known as lateral) chromatic aberrations
  * vignetting
  * colour contribution of the lens (correcting said "yellowish" or "blueish"
    images)
 .
 It provides a way to read and search for specific things in the database.
 .
 This package contains the development files.

Package: liblensfun1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 liblensfun-data-v1 (>= ${source:Version})
Multi-Arch: same
Description: Lens Correction library - Runtime files
 Lensfun is an opensource database of photographic lenses and their
 characteristics. It contains three kinds of objects:
  * mounts
  * cameras
  * lenses
 .
 It is used in various photo-related software in which it allows the
 correction of various artifacts:
  * distortion
  * transveral (also known as lateral) chromatic aberrations
  * vignetting
  * colour contribution of the lens (correcting said "yellowish" or "blueish"
    images)
 .
 It provides a way to read and search for specific things in the database.
 .
 This package contains the runtime files to access the library.

Package: liblensfun-data-v1
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Lens Correction library - Data
 Lensfun is an opensource database of photographic lenses and their
 characteristics. It contains three kinds of objects:
  * mounts
  * cameras
  * lenses
 .
 It is used in various photo-related software in which it allows the
 correction of various artifacts:
  * distortion
  * transveral (also known as lateral) chromatic aberrations
  * vignetting
  * colour contribution of the lens (correcting said "yellowish" or "blueish"
    images)
 .
 It provides a way to read and search for specific things in the database.
 .
 This package contains the data collection.

Package: liblensfun-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-mathjax
Description: Lens Correction library - Documentation
 Lensfun is an opensource database of photographic lenses and their
 characteristics. It contains three kinds of objects:
  * mounts
  * cameras
  * lenses
 .
 It is used in various photo-related software in which it allows the
 correction of various artifacts:
  * distortion
  * transveral (also known as lateral) chromatic aberrations
  * vignetting
  * colour contribution of the lens (correcting said "yellowish" or "blueish"
    images)
 .
 It provides a way to read and search for specific things in the database.
 .
 This package contains the documentation.

Package: liblensfun-bin
Section: utils
Architecture: any
Depends: python3, python3-lensfun (= ${binary:Version}), ${misc:Depends}
Description: Lens Correction library - Utilities
 Lensfun is an opensource database of photographic lenses and their
 characteristics. It contains three kinds of objects:
  * mounts
  * cameras
  * lenses
 .
 It is used in various photo-related software in which it allows the
 correction of various artifacts:
  * distortion
  * transveral (also known as lateral) chromatic aberrations
  * vignetting
  * colour contribution of the lens (correcting said "yellowish" or "blueish"
    images)
 .
 It provides a way to read and search for specific things in the database.
 .
 This package contains the utilities.

Package: python3-lensfun
Section: python
Architecture: any
Depends: liblensfun1 (= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
Description: Lens Correction library - Python3 module
 Lensfun is an opensource database of photographic lenses and their
 characteristics. It contains three kinds of objects:
  * mounts
  * cameras
  * lenses
 .
 It is used in various photo-related software in which it allows the
 correction of various artifacts:
  * distortion
  * transveral (also known as lateral) chromatic aberrations
  * vignetting
  * colour contribution of the lens (correcting said "yellowish" or "blueish"
    images)
 .
 It provides a way to read and search for specific things in the database.
 .
 This package contains the Python3 'lensfun' module.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH_CPU),amd64)
  EXTRA_CMAKE_ARGS += -DBUILD_FOR_SSE=ON -DBUILD_FOR_SSE2=ON
else
  EXTRA_CMAKE_ARGS += -DBUILD_FOR_SSE=OFF -DBUILD_FOR_SSE2=OFF
endif

%:
	dh $@ --with=python3

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_DOC=ON -DCMAKE_INSTALL_DOCDIR="/usr/share/doc/liblensfun-doc/html" -DBUILD_TESTS=ON $(EXTRA_CMAKE_ARGS)

execute_before_dh_auto_clean:
	find -name "*.pyc" -exec rm -f '{}' \;

## lensfun 0.3.4

=== libs/regex/CMakeLists.txt ===
# build regex library
IF(NOT HAVE_REGEX_H)
FILE(GLOB REGEX_SRC *.c *.h)
LIST(APPEND REGEX_SRC ../../include/regex/regex.h)
ADD_LIBRARY(tre_regex STATIC ${REGEX_SRC})
SET_TARGET_PROPERTIES(tre_regex PROPERTIES COMPILE_FLAGS "-DHAVE_SYS_TYPES_H -DTRE_REGEX_T_FIELD=value -DTRE_VERSION=\\\"0.8.0\\\" -Dinline=_inline")
SET_TARGET_PROPERTIES(tre_regex PROPERTIES VERSION "${VERSION_MAJOR}.${VERSION_MINOR}).${VERSION_MICRO}")  
INSTALL(TARGETS tre_regex ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
ENDIF()

=== debian/changelog ===
lensfun (1:0.3.4-2) unstable; urgency=medium

  * Bump epoch to 1 to revert the mess done in unstable by uploading an
    experimental/development version NOT meant for unstable.
  * Pass -DCMAKE_POLICY_VERSION_MINIMUM=3.5 to cmake so it builds with cmake 4
    (hoping that everything works properly). (Closes: #1113100)
  * Switch the transitional pkg-config build dependency to pkgconf.

 -- Pino Toscano <pino@debian.org>  Tue, 07 Oct 2025 07:40:30 +0200

lensfun (0.3.4-1) unstable; urgency=medium

  * New upstream release.
  * Update standards version to 4.6.2, no changes needed.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 2.8.12
    - add python3-setuptools
  * Fix the setuptools-based installation of the Python module:
    - export DEB_PYTHON_INSTALL_LAYOUT=deb so that the Python bits are installed
      in the expected way for Debian builds (see #1041633)
    - tweak the arguments for 'setup.py install'; patch python-setuptools.diff
  * Remove inactive Uploaders.
  * Update lintian overrides.
  * Fix the handling of min/max float limits for comparisons, fixing the lens
    search on certain architectures (e.g. i386); patch fix-float.diff.

 -- Pino Toscano <pino@debian.org>  Sat, 12 Aug 2023 08:02:34 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: lensfun
 Priority: optional
 Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
-Uploaders: Mark Purcell <msp@debian.org>,
- Pino Toscano <pino@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake, pkg-config, python3:any, libglib2.0-dev,
+Uploaders: Pino Toscano <pino@debian.org>
+Build-Depends: debhelper-compat (= 13), cmake (>= 2.8.12~), pkgconf, python3:any, libglib2.0-dev,
  dh-python,
  doxygen,
  python3-docutils,
-Standards-Version: 4.6.0
+ python3-setuptools,
+Standards-Version: 4.6.2
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://lensfun.github.io/

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH_CPU),amd64)
  EXTRA_CMAKE_ARGS += -DBUILD_FOR_SSE=ON -DBUILD_FOR_SSE2=ON
else
  EXTRA_CMAKE_ARGS += -DBUILD_FOR_SSE=OFF -DBUILD_FOR_SSE2=OFF
endif

# needed to install the Python bits to /usr
export DEB_PYTHON_INSTALL_LAYOUT=deb

%:
	dh $@ --with=python3

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_POLICY_VERSION_MINIMUM=3.5 -DBUILD_DOC=ON -DCMAKE_INSTALL_DOCDIR="/usr/share/doc/liblensfun-doc/html" -DBUILD_TESTS=ON $(EXTRA_CMAKE_ARGS)

execute_before_dh_auto_clean:
	find -name "*.pyc" -exec rm -f '{}' \;

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%lensfun-$1.tar.gz%" \
  https://github.com/lensfun/lensfun/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## lensfun 0.3.95

=== apps/CMakeLists.txt ===
IF(BUILD_LENSTOOL)
    IF(WIN32)
      INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/libs/getopt)
    ENDIF()
    FIND_PACKAGE(PNG REQUIRED)
    INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
    INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
    INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
    ADD_EXECUTABLE(lenstool lenstool/lenstool.cpp lenstool/image.cpp)
    TARGET_LINK_LIBRARIES(lenstool lensfun ${PNG_LIBRARY} ${ZLIB_LIBRARY})
    INSTALL(TARGETS lenstool DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF()


IF(INSTALL_HELPER_SCRIPTS)
  INSTALL(PROGRAMS g-lensfun-update-data lensfun-add-adapter lensfun-update-data lensfun-convert-lcp
          DESTINATION ${CMAKE_INSTALL_BINDIR})
ENDIF(INSTALL_HELPER_SCRIPTS)


# Inspired by http://bloerg.net/2012/11/10/cmake-and-distutils.html

FIND_PROGRAM(PYTHON "python3")
IF(PYTHON)
    SET(SETUP_PY_IN "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
    SET(SETUP_PY    "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
    SET(DEPS_IN     "${CMAKE_CURRENT_SOURCE_DIR}/lensfun/__init__.py.in")
    SET(DEPS        "${CMAKE_CURRENT_BINARY_DIR}/lensfun/__init__.py")
    SET(OUTPUT      "${CMAKE_CURRENT_BINARY_DIR}/build/timestamp")

    CONFIGURE_FILE(${SETUP_PY_IN} ${SETUP_PY})
    CONFIGURE_FILE(${DEPS_IN} ${DEPS})

    ADD_CUSTOM_COMMAND(OUTPUT ${OUTPUT}
                       COMMAND ${PYTHON} ${SETUP_PY} build
                       COMMAND ${CMAKE_COMMAND} -E touch ${OUTPUT}
                       DEPENDS ${DEPS_IN})

    ADD_CUSTOM_TARGET(python-package ALL DEPENDS ${OUTPUT})

    IF(NOT DEFINED SETUP_PY_INSTALL_PREFIX)
      SET(SETUP_PY_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
    ENDIF()
    INSTALL(CODE "execute_process(COMMAND ${PYTHON} ${SETUP_PY} install --prefix=\$ENV{DESTDIR}${SETUP_PY_INSTALL_PREFIX})")
ENDIF(PYTHON)

=== docs/CMakeLists.txt ===
# find doxygen
FIND_PACKAGE(Doxygen REQUIRED)

# set some files/path for later user
# we don't use path doc because path doc is used by cmake itself because
# of target doc
SET(CMAKE_DOC_OUT ${CMAKE_BINARY_DIR}/doc_doxygen)
set(DOXYFILE "${CMAKE_CURRENT_BINARY_DIR}/doxyfile")

# create doxyfile
CONFIGURE_FILE(doxyfile.in.cmake ${DOXYFILE} @ONLY)

# now build documentation
ADD_CUSTOM_TARGET(doc
  ALL
  COMMAND "${DOXYGEN_EXECUTABLE}"
  DEPENDS "${DOXYFILE}" manual-main.txt ../include/lensfun/lensfun.h.in
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  COMMENT "Building documentation with doxygen"
)

# install documentation  
INSTALL(DIRECTORY ${CMAKE_DOC_OUT}/ DESTINATION ${CMAKE_INSTALL_DOCDIR})

# create and install man pages
FIND_PROGRAM(RST2MAN_EXECUTABLE NAMES rst2man rst2man.py rst2man2 rst2man2.py)
ADD_CUSTOM_TARGET(man ALL)
ADD_CUSTOM_COMMAND(
  TARGET man
  COMMAND ${RST2MAN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/man/g-lensfun-update-data.1.rst > ${CMAKE_CURRENT_BINARY_DIR}/g-lensfun-update-data.1
  COMMAND ${RST2MAN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/man/lensfun-update-data.1.rst > ${CMAKE_CURRENT_BINARY_DIR}/lensfun-update-data.1
  COMMAND ${RST2MAN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/man/lensfun-add-adapter.1.rst > ${CMAKE_CURRENT_BINARY_DIR}/lensfun-add-adapter.1
  COMMAND ${RST2MAN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/man/lensfun-convert-lcp.1.rst > ${CMAKE_CURRENT_BINARY_DIR}/lensfun-convert-lcp.1
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
)

INSTALL(FILES 
    ${CMAKE_CURRENT_BINARY_DIR}/g-lensfun-update-data.1 
    ${CMAKE_CURRENT_BINARY_DIR}/lensfun-update-data.1 
    ${CMAKE_CURRENT_BINARY_DIR}/lensfun-add-adapter.1 
    DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
)

=== libs/CMakeLists.txt ===
ADD_SUBDIRECTORY(lensfun)

# also build getopt on windows
IF(WIN32 AND BUILD_LENSTOOL)
  ADD_SUBDIRECTORY(getopt)
ENDIF()

=== tests/CMakeLists.txt ===
find_package(OpenMP)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")

ADD_EXECUTABLE(test_database test_database.cpp)
TARGET_LINK_LIBRARIES(test_database lensfun ${COMMON_LIBS})
ADD_TEST(NAME Database WORKING_DIRECTORY ${CMAKE_SOURCE_DIR} COMMAND test_database)

ADD_EXECUTABLE(test_lens test_lens.cpp)
TARGET_LINK_LIBRARIES(test_lens lensfun ${COMMON_LIBS})
ADD_TEST(Lens test_lens)

ADD_EXECUTABLE(test_modifier test_modifier.cpp)
TARGET_LINK_LIBRARIES(test_modifier lensfun ${COMMON_LIBS})
ADD_TEST(Modifier test_modifier)

ADD_EXECUTABLE(test_modifier_performance test_modifier_performance.cpp)
TARGET_LINK_LIBRARIES(test_modifier_performance lensfun ${COMMON_LIBS})
ADD_TEST(NAME Modifier_performance WORKING_DIRECTORY ${CMAKE_SOURCE_DIR} COMMAND test_modifier_performance)

find_package(OpenMP)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")

ADD_EXECUTABLE(test_modifier_color test_modifier_color.cpp)
TARGET_LINK_LIBRARIES(test_modifier_color lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_color test_modifier_color)

ADD_EXECUTABLE(test_modifier_subpix test_modifier_subpix.cpp)
TARGET_LINK_LIBRARIES(test_modifier_subpix lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_subpix test_modifier_subpix)

ADD_EXECUTABLE(test_modifier_coord_scale test_modifier_coord_scale.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_scale lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_scale test_modifier_coord_scale)

ADD_EXECUTABLE(test_modifier_coord_perspective_correction test_modifier_coord_perspective_correction.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_perspective_correction lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_perspective_correction test_modifier_coord_perspective_correction)

ADD_EXECUTABLE(test_modifier_coord_distortion test_modifier_coord_distortion.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_distortion lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_distortion test_modifier_coord_distortion)

ADD_EXECUTABLE(test_modifier_coord_geometry test_modifier_coord_geometry.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_geometry lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_geometry test_modifier_coord_geometry)

ADD_EXECUTABLE(test_modifier_coord_tiny_image test_modifier_coord_tiny_image.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_tiny_image lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_tiny_image test_modifier_coord_tiny_image)

ADD_EXECUTABLE(test_modifier_coord_centering test_modifier_coord_centering.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_centering lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_centering test_modifier_coord_centering)

ADD_EXECUTABLE(test_modifier_regression test_modifier_regression.cpp)
TARGET_LINK_LIBRARIES(test_modifier_regression lensfun ${COMMON_LIBS})
ADD_TEST(NAME Modifier_regression WORKING_DIRECTORY ${CMAKE_SOURCE_DIR} COMMAND test_modifier_regression)


### Deprecated API tests
ADD_EXECUTABLE(test_database_old test_database_old.cpp)
TARGET_LINK_LIBRARIES(test_database_old lensfun ${COMMON_LIBS})
ADD_TEST(NAME Database_deprecated WORKING_DIRECTORY ${CMAKE_SOURCE_DIR} COMMAND test_database_old)

ADD_EXECUTABLE(test_modifier_old test_modifier_old.cpp)
TARGET_LINK_LIBRARIES(test_modifier_old lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_deprecated test_modifier_old)

ADD_EXECUTABLE(test_modifier_color_old test_modifier_color_old.cpp)
TARGET_LINK_LIBRARIES(test_modifier_color_old lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_color_deprecated test_modifier_color_old)

ADD_EXECUTABLE(test_modifier_subpix_old test_modifier_subpix_old.cpp)
TARGET_LINK_LIBRARIES(test_modifier_subpix_old lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_subpix_deprecate test_modifier_subpix_old)

ADD_EXECUTABLE(test_modifier_coord_scale_old test_modifier_coord_scale_old.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_scale_old lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_scale_deprecated test_modifier_coord_scale_old)

ADD_EXECUTABLE(test_modifier_coord_perspective_correction_old test_modifier_coord_perspective_correction_old.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_perspective_correction_old lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_perspective_correction_deprecated test_modifier_coord_perspective_correction_old)

ADD_EXECUTABLE(test_modifier_coord_distortion_old test_modifier_coord_distortion_old.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_distortion_old lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_distortion_deprecated test_modifier_coord_distortion_old)

ADD_EXECUTABLE(test_modifier_coord_geometry_old test_modifier_coord_geometry_old.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_geometry_old lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_geometry_deprecated test_modifier_coord_geometry_old)

ADD_EXECUTABLE(test_modifier_coord_tiny_image_old test_modifier_coord_tiny_image_old.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_tiny_image_old lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_tiny_image_deprecated test_modifier_coord_tiny_image_old)

ADD_EXECUTABLE(test_modifier_coord_centering_old test_modifier_coord_centering_old.cpp)
TARGET_LINK_LIBRARIES(test_modifier_coord_centering_old lensfun ${COMMON_LIBS})
ADD_TEST(Modifier_coord_centering_deprecated test_modifier_coord_centering_old)

ADD_EXECUTABLE(test_modifier_regression_old test_modifier_regression_old.cpp)
TARGET_LINK_LIBRARIES(test_modifier_regression_old lensfun ${COMMON_LIBS})
ADD_TEST(NAME Modifier_regression_deprecated WORKING_DIRECTORY ${CMAKE_SOURCE_DIR} COMMAND test_modifier_regression_old)

ADD_EXECUTABLE(test_lffuzzystrcmp test_lffuzzystrcmp.cpp)
TARGET_LINK_LIBRARIES(test_lffuzzystrcmp lensfun ${COMMON_LIBS})
ADD_TEST(test_lffuzzystrcmp test_lffuzzystrcmp)

FIND_PACKAGE(PythonInterp REQUIRED)
ADD_TEST(NAME Database_integrity COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/check_database/check_database.py ${CMAKE_SOURCE_DIR}/data/db)

=== libs/getopt/CMakeLists.txt ===
ADD_LIBRARY(getopt STATIC getopt.c getopt.h)

=== debian/changelog ===
lensfun (0.3.95-8) unstable; urgency=medium

  * Team upload.
  * Reapply x86 build fix from Adrian Bunk.

 -- Steve M. Robbins <smr@debian.org>  Mon, 06 Oct 2025 23:42:06 -0500

lensfun (0.3.95-7) unstable; urgency=medium

  * Team upload.
  * CMakeLists: raise minimum version.  Closes: #1113100.

 -- Steve M. Robbins <smr@debian.org>  Mon, 06 Oct 2025 20:00:59 -0500

lensfun (0.3.95-6) experimental; urgency=medium

  * Merge changes from 0.3.4-1:
    - refresh fix-float.diff to avoid fuzz
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Sat, 12 Aug 2023 09:06:20 +0200

lensfun (0.3.95-5) experimental; urgency=medium

  * Backport upstream commit a4f8629317d8818f499c765e88188a579dfd684a to
    increase the tolerance in tests involving SVD (should hopefully fix those
    tests on some architectures); patch
    upstream_Increase-tolerance-for-tests-involving-SVD.-1136.patch.

 -- Pino Toscano <pino@debian.org>  Mon, 04 Jul 2022 20:16:19 +0200

lensfun (0.3.95-4) experimental; urgency=medium

  * Merge changes from 0.3.3-1.
  * Replace patch tests-x86.diff with upstream commit
    c3431aeb1d5b3b5504fd85c2b2f85dddbafbb3f4; patch
    upstream_tests-build-test_modifier_performance-only-on-x86-10.patch.
  * Mark the libxml2-utils build dependency as !nocheck, as it is used only
    when running dh_auto_test.

 -- Pino Toscano <pino@debian.org>  Tue, 15 Mar 2022 23:51:11 +0100

lensfun (0.3.95-3) experimental; urgency=medium

  * Merge changes from 0.3.2-6.
  * Switch Vcs-* fields to the experimental branch.

 -- Pino Toscano <pino@debian.org>  Sun, 07 Feb 2021 12:38:53 +0100

lensfun (0.3.95-2) experimental; urgency=medium

  * Backport upstream commit de954c952929316ea2ad0f6f1e336d9d8164ace0 to fix
    allocation of buffers for strings; patch
    upstream_Allocate-string-with-sufficient-length-to-include-a-.patch.
  * Build test_modifier_performance only on x86, as it uses SSE APIs; patch
    tests-x86.diff.

 -- Pino Toscano <pino@debian.org>  Sun, 09 Feb 2020 12:05:21 +0100

lensfun (0.3.95-1) experimental; urgency=medium

  * New upstream development release.
  * Rename packages according to the new upstream SONAME, and DB version:
    - liblensfun1 -> liblensfun2
    - liblensfun-data-v1 -> liblensfun-data-v2
  * Update the patches:
    - upstream_Use-database-in-source-directory-while-running-tests.patch:
      drop, backported from upstream
    - upstream_Patch-47-respect-DESTDIR-when-installing-python-stuf.patch:
      drop, backported from upstream
  * Add the libxml2-utils build dependency, as xmllint is used in one test.
  * Update install files.
  * Backport parts of upstream commit b9540f30f880e723d51cd1438ef1b7506251309f
    to build with -Wformat-security (default in Debian); patch
    upstream_Enable-Wformat-security-and-fix-respective-warnings.patch.

 -- Pino Toscano <pino@debian.org>  Wed, 05 Feb 2020 21:18:11 +0100

=== debian/control ===
--- 
+++ 
@@ -7,17 +7,18 @@
  doxygen,
  python3-docutils,
  python3-setuptools,
+ libxml2-utils <!nocheck>,
 Standards-Version: 4.6.2
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://lensfun.github.io/
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/lensfun
-Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/lensfun.git
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/lensfun/-/tree/experimental
+Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/lensfun.git -b experimental
 
 Package: liblensfun-dev
 Section: libdevel
 Architecture: any
-Depends: liblensfun1 (= ${binary:Version}), ${misc:Depends}
+Depends: liblensfun2 (= ${binary:Version}), ${misc:Depends}
 Description: Lens Correction library - Development files
  Lensfun is an opensource database of photographic lenses and their
  characteristics. It contains three kinds of objects:
@@ -37,10 +38,10 @@
  .
  This package contains the development files.
 
-Package: liblensfun1
+Package: liblensfun2
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
- liblensfun-data-v1 (>= ${source:Version})
+ liblensfun-data-v2 (>= ${source:Version})
 Multi-Arch: same
 Description: Lens Correction library - Runtime files
  Lensfun is an opensource database of photographic lenses and their
@@ -61,7 +62,7 @@
  .
  This package contains the runtime files to access the library.
 
-Package: liblensfun-data-v1
+Package: liblensfun-data-v2
 Architecture: all
 Depends: ${misc:Depends}
 Multi-Arch: foreign
@@ -133,7 +134,7 @@
 Package: python3-lensfun
 Section: python
 Architecture: any
-Depends: liblensfun1 (= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
+Depends: liblensfun2 (= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
 Description: Lens Correction library - Python3 module
  Lensfun is an opensource database of photographic lenses and their
  characteristics. It contains three kinds of objects:

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH_CPU),amd64)
  EXTRA_CMAKE_ARGS += -DBUILD_FOR_SSE=ON -DBUILD_FOR_SSE2=ON
else
  EXTRA_CMAKE_ARGS += -DBUILD_FOR_SSE=OFF -DBUILD_FOR_SSE2=OFF
endif

export DEB_CXXFLAGS_MAINT_APPEND += -fexcess-precision=fast

# needed to install the Python bits to /usr
export DEB_PYTHON_INSTALL_LAYOUT=deb

%:
	dh $@ --with=python3

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_DOC=ON -DCMAKE_INSTALL_DOCDIR="/usr/share/doc/liblensfun-doc/html" -DBUILD_TESTS=ON $(EXTRA_CMAKE_ARGS)

execute_before_dh_auto_clean:
	find -name "*.pyc" -exec rm -f '{}' \;
